//
// Logging Interface for LCDHype
//
// $Id: LogInterface.h 8 2012-09-30 15:20:43Z LostSoul $
//

#ifndef LOGINTERFACE_H_
#define LOGINTERFACE_H_

#warning "Enum size is compiler specific, ensure size is 4 bytes"
#pragma pack(push, 4)

typedef unsigned long LongWord;
typedef bool Boolean;
typedef wchar_t WideChar;
typedef WideChar * PWideChar;

// structures

enum TLogInterfaceEntryKind
{
  ekUnknown = 0,
  ekInfo = 1,
  ekAttention = 2,
  ekError = 3
};

struct TLogInterfaceEntry
{
  LongWord StructureSize;
  TLogInterfaceEntryKind Kind;
  PWideChar Source;
  PWideChar Text;
};
typedef TLogInterfaceEntry * PLogInterfaceEntry;

// callbacks

typedef bool (__stdcall * TLogInterfaceAddEntryCallBack)(PLogInterfaceEntry ALogEntry);

#pragma pack(pop)

#endif
