//
// LCDHype script engine interface, requires LCDHype version 0.7.4.5 or above
//
// $Id: ScriptEngineInterface.h 8 2012-09-30 15:20:43Z LostSoul $
//

#ifndef SCRIPTENGINEINTERFACE_H_
#define SCRIPTENGINEINTERFACE_H_

#warning "Enum size is compiler specific, ensure size is 4 bytes"
#pragma pack(push, 4)

typedef unsigned long LongWord;
typedef wchar_t WideChar;
typedef WideChar * PWideChar;

struct TScriptFunctionParameter
{
  LongWord StructureSize;
  PWideChar Name;
  PWideChar Value;
};
typedef TScriptFunctionParameter * PScriptFunctionParameter;

struct TScriptFunctionImplementationParameter
{
  LongWord StructureSize;
  PWideChar Name;  // script function name, this is the string between % and (
  LongWord ParameterCount; // number of TScriptFunctionParameter structures passed by ParameterList
  PScriptFunctionParameter ParameterList;
};
typedef TScriptFunctionImplementationParameter * PScriptFunctionImplementationParameter;

// returned PChar needs to be a valid pointer (e.g. from a global return value
// buffer) to the first character of the return value, due to performance
// reasons LCDHype does not free the memory behind the returned pointer,
// so be cautious with the returned pointer to avoid memory leaks
typedef PWideChar (__stdcall * TScriptFunctionImplementation)(const PScriptFunctionImplementationParameter AParameter);

#endif
