//
// LCDHype LCD driver implementation
//
// $Revision: 7 $
//
// $Id: Main.cpp 7 2012-09-30 15:13:01Z LostSoul $
//

#include "Main.h"
#include <string>

std::wstring gLibraryPath(L"");
const wchar_t * gLibraryName(L"C++ LCD Driver SDK");
std::wstring gMyScriptFunctionReturnValue(L"");
TLogInterfaceAddEntryCallBack gAddLogEntryCallback(0);

void __stdcall Library_GetProperty(PControllerInterfaceGetProperty AProperty)
{
  if (AProperty->StructureSize >= sizeof(TControllerInterfaceGetProperty))
  {
    switch (AProperty->Kind)
    {
      case gpName:
      {
        AProperty->Value = (void *)gLibraryName;
        break;
      }

      case gpTextModeResolution:
      {
        // handle gpTextModeResolution to support text output
        PControllerInterfaceResolution lResolution((PControllerInterfaceResolution)AProperty->Value);
        lResolution->Width = 40;
        lResolution->Height = 30;

        break;
      }

      case gpFontPitch:
      {
        // font pitch of LCD
        PByte lByteProperty((PByte)AProperty->Value);

        *lByteProperty = 6;

        break;
      }

      case gpCustomCharPosition:
      {
        // font pitch of LCD
        PControllerInterfaceCustomCharPosition lCustomCharPosition((PControllerInterfaceCustomCharPosition)AProperty->Value);

        lCustomCharPosition->Memory = lCustomCharPosition->Internal + 128;

        break;
      }

      case gpCustomCharCount:
      {
        PLongWord lByteProperty((PLongWord)AProperty->Value);

        *lByteProperty = 64;

        break;
      }

      default:
      {
        break;
      }
    }
  }
}

void __stdcall Library_SetProperty(PControllerInterfaceSetPropertyList  AProperty)
{
  if (AProperty->StructureSize >= sizeof(TControllerInterfaceSetPropertyList))
  {
    for (int c(0); c < AProperty->Length; ++c)
    {
      PControllerInterfaceSetProperty lProperty(&AProperty->Element[c]);

      switch (lProperty->Kind)
      {
        case spLibraryPath:
        {
          gLibraryPath = (PWideChar)lProperty->Value;

          if (gAddLogEntryCallback)
          {
            TLogInterfaceEntry e;
            e.StructureSize = sizeof(TLogInterfaceEntry);
            e.Kind = ekInfo;
            e.Source = const_cast<PWideChar>(gLibraryName);
            e.Text = const_cast<PWideChar>(gLibraryPath.c_str());

            gAddLogEntryCallback(&e);
          }

          break;
        }

        case spAddLogEntryCallback:
        {
          gAddLogEntryCallback = (TLogInterfaceAddEntryCallBack)lProperty->Value;

          break;
        }

        default:
        {
          break;
        }
      }
    }
  }
}

void __stdcall Library_Init(PControllerInterfaceInitParameter /* AProperty */)
{}

void __stdcall Library_CleanUp(PControllerInterfaceCleanUpParameter /* AProperty */)
{}

void __stdcall Library_SendCustomChar(PControllerInterfaceCustomChar /* AProperty */)
{}

Boolean __stdcall Library_SendCommand(PControllerInterfaceCommand /* AProperty */)
{
  return false;
}

void __stdcall Library_SendText(PControllerInterfaceText /* AProperty */)
{}

void __stdcall Library_SendBitmap(PControllerInterfaceBitmap /* AProperty */)
{}

void __stdcall Library_SendSymbol(PControllerInterfaceSymbol /* AProperty */)
{}

// start script engine interface

PWideChar __stdcall Library_MyScriptFunction(const PScriptFunctionImplementationParameter AParameter)
{
  gMyScriptFunctionReturnValue = L"";
  if (AParameter->StructureSize == sizeof(TScriptFunctionImplementationParameter))
  {
    // simply return the parameter names and values passed to this function
    if (AParameter->ParameterCount > 0)
    {
      for (LongWord c(0); c < AParameter->ParameterCount; ++c)
      {
        if (!gMyScriptFunctionReturnValue.empty())
          gMyScriptFunctionReturnValue = gMyScriptFunctionReturnValue + L"%Common.CreateNewLine()";

        gMyScriptFunctionReturnValue = gMyScriptFunctionReturnValue +
                                       AParameter->ParameterList[c].Name + L"=" +
                                       AParameter->ParameterList[c].Value;

      }
    }
  }

  return const_cast<PWideChar>(gMyScriptFunctionReturnValue.c_str());
}

// end script engine interface
