//
// LCDHype LCD driver declaration
//
// Requirements
//   - LCDHype version mentioned in ControllerInterface.h
//   - LogInterface.h and LCDHype version mentioned in this file (optional)
//   - ScriptEngineInterface.h and LCDHype version mentioned in this file (optional)
//
// $Revision: 7 $
//
// $Id: Main.h 7 2012-09-30 15:13:01Z LostSoul $
//

#ifndef MAIN_H_
#define MAIN_H_

#include "ControllerInterface.h"    // for TControllerInterface types
#include <LogInterface.h>           // for logging purposes
#include <ScriptEngineInterface.h>  // for TScriptFunctionImplementation

void __stdcall Library_GetProperty(PControllerInterfaceGetProperty AProperty);
void __stdcall Library_SetProperty(PControllerInterfaceSetPropertyList AProperty);
void __stdcall Library_Init(PControllerInterfaceInitParameter AProperty);
void __stdcall Library_CleanUp(PControllerInterfaceCleanUpParameter AProperty);
void __stdcall Library_SendCustomChar(PControllerInterfaceCustomChar AProperty);
Boolean __stdcall Library_SendCommand(PControllerInterfaceCommand AProperty);
void __stdcall Library_SendText(PControllerInterfaceText AProperty);
void __stdcall Library_SendBitmap(PControllerInterfaceBitmap AProperty);
void __stdcall Library_SendSymbol(PControllerInterfaceSymbol AProperty);

PWideChar __stdcall Library_MyScriptFunction(const PScriptFunctionImplementationParameter AParameter);

// pointers to controller interface functions called by LCDHype
TControllerInterfaceGetPropertyMethod GetProperty(&Library_GetProperty);
TControllerInterfaceSetPropertyMethod SetProperty(&Library_SetProperty);
TControllerInterfaceInitMethod Init(&Library_Init);
TControllerInterfaceCleanUpMethod CleanUp(&Library_CleanUp);
TControllerInterfaceSendCustomCharMethod SendCustomChar(&Library_SendCustomChar);
TControllerInterfaceSendCommandMethod SendCommand(&Library_SendCommand);
TControllerInterfaceSendTextMethod SendText(&Library_SendText);
TControllerInterfaceSendBitmapMethod SendBitmap(&Library_SendBitmap);
TControllerInterfaceSendSymbolMethod SendSymbol(&Library_SendSymbol);

// pointers to script engine interface functions called by LCDHype
TScriptFunctionImplementation MyScriptFunction(&Library_MyScriptFunction);

#endif
